-- name: [CS] \\#FF0040\\kitsufae
-- description: dumb kitsune\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local TEXT_MOD_NAME = "kitsufae"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_FAE = smlua_model_util_get_id("fae_geo")

local TEX_FAE_ICON = get_texture_info("fae-icon")
local TEX_FAEPLUSH_ICON = get_texture_info("plush-icon")


VOICETABLE_FAE = {nil}

local E_MODEL_FAEPLUSH = smlua_model_util_get_id("faeplush_geo")

local PALETTE_FAE = {
    [PANTS]  = "603737",
    [SHIRT]  = "ff0020",
    [GLOVES] = "d8d1ff",
    [SHOES]  = "333333",
    [HAIR]   = "d96c7f",
    [SKIN]   = "ffffff",
    [CAP]    = "ff0020",
}

local faeMeter = {
    label = {
        left = get_texture_info("fae-hp-back-left"),
        right = get_texture_info("fae-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("fae-hp-pie-1"),
        [2] = get_texture_info("fae-hp-pie-2"),
        [3] = get_texture_info("fae-hp-pie-3"),
        [4] = get_texture_info("fae-hp-pie-4"),
        [5] = get_texture_info("fae-hp-pie-5"),
        [6] = get_texture_info("fae-hp-pie-6"),
        [7] = get_texture_info("fae-hp-pie-7"),
        [8] = get_texture_info("fae-hp-pie-8"),
    }
}

--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    CT_FAE = _G.charSelect.character_add("Fae", {"the kitsune with a coffee addiciton"}, "kitsufae", {r = 255, g = 0, b = 64}, E_MODEL_FAE, CT_MARIO, TEX_FAE_ICON)
    _G.charSelect.character_add_voice(E_MODEL_FAE, VOICETABLE_FAE)
    _G.charSelect.character_add_celebration_star(E_MODEL_FAE, E_MODEL_FAEPLUSH, TEX_FAEPLUSH_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_FAE, PALETTE_FAE)
    _G.charSelect.character_add_health_meter(CT_FAE, faeMeter)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FAE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FAE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)